'use strict';

var _chai = require('chai');

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _trailShimmer = require('trail-shimmer');

var _trailShimmer2 = _interopRequireDefault(_trailShimmer);

var _trailAgent = require('trail-agent');

var _trailAgent2 = _interopRequireDefault(_trailAgent);

var _ = require('.');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('bluebird main wrap', function () {
    _trailAgent2.default.setRecorder(() => {});
    let sandbox;

    beforeEach(() => {
        sandbox = _sinon2.default.sandbox.create();
    });

    afterEach(() => {
        sandbox.restore();
    });

    it('should wrap bluebird.prototype._addCallbacks', function () {
        let shimmerWrapStub = sandbox.stub(_trailShimmer2.default, 'wrap');

        function bluebird() {
            // return itself (constructor)
            return bluebird;
        }
        bluebird.prototype._addCallbacks = function () {};

        _2.default.wrap(_trailAgent2.default, bluebird);

        (0, _chai.expect)(shimmerWrapStub).to.have.been.calledWith(bluebird.prototype, 'Bluebird.prototype', '_addCallbacks');
    });
});